<?php

  require_once("Course.class.php");
  require_once("Student.class.php");
  require_once("Subscription.class.php");
  require_once("Weekeval.class.php");
  require_once "Classes/Comment.class.php";
  require_once("Includes/config.inc.php");
  require_once("Includes/functions.inc.php");

  class DataBase {

    // MEMBERS
    public $connection;
    public $connected = false;

    // CONSTRUCTOR AND CONNECTION FUNCTIONS
    public function DataBase($checkDatabase=true) {
      if ($checkDatabase && (!$this->tryConnect() || !$this->isComplete())) {
        if (!endsWith($_SERVER['PHP_SELF'], "setup.php")) header("location: setup.php");
        return;
      }
      if ($checkDatabase && (!$this->isDataBaseLoaded())) {
       if (!endsWith($_SERVER['PHP_SELF'], "import.php")&&!endsWith($_SERVER['PHP_SELF'], "setup.php")) header("location: import.php");
       return;
      $this->connect();
      }
    }

    public function connect() {
      global $MYSQLCONFIG;
      $this->connection = @mysql_connect($MYSQLCONFIG['host'], $MYSQLCONFIG['user'], $MYSQLCONFIG['password'])
        or showError("Unable to connect to database (please review your <a href='setup.php'>settings</a>)");
      @mysql_select_db($MYSQLCONFIG['database']) or showError("Unable to select database '".$MYSQLCONFIG['database']."' (please review your <a href='setup.php'>settings</a>)");
      $this->connected = true;
    }

    public function tryConnect() {
      global $MYSQLCONFIG;
      if (!$this->connection = @mysql_connect($MYSQLCONFIG['host'], $MYSQLCONFIG['user'], $MYSQLCONFIG['password'])) return false;
      if (!@mysql_select_db($MYSQLCONFIG['database'])) return false;
      $this->connected = true;
      return true;
    }

    public function isConnected() {
      return $this->connected;
    }

    public function isComplete() {
      if (!$this->isConnected()) return false;
      if ($this->getParameter("complete")!=1) return false;
      return true;
    }

    public function getParameter($name) {
      $query = "SELECT * FROM parameters WHERE parameter_name='".$name."'";
      if (!$result = @mysql_query($query)) return false;
      if (!$parameter = @mysql_fetch_array($result)) return false;
      return $parameter['parameter_value'];
    }

    public function setParameter($name, $val) {
      $query = "SELECT * FROM parameters WHERE parameter_name='".$name."'";
      $result = @mysql_query($query) or showError("Unable to search for parameter");
      if (mysql_num_rows($result)>0) {
        $query = "UPDATE parameters SET parameter_value='".$parValue."' WHERE parameter_name='".$name."'";
      } else {
        $query = "INSERT INTO parameters (parameter_name, parameter_value) VALUES ('".$name."','".$val."')";
      }
      @mysql_query($query) or showError("Unable to set parameter");
    }


    // PRIVATE FUNCTIONS
    private function getFirstValue($query, $errMsg) {
      $result      = @mysql_query($query) or showError($errMsg);
      $firstRecord = @mysql_fetch_array($result) or showError($errMsg);
      return $firstRecord[0];
    }

    private function getFirstRecord($query, $errMsg, $errIfNotUnique=true) {
      $result = @mysql_query($query) or showError($errMsg);
      if (mysql_num_rows($result)<1) showError($errMsg);
      if ($errIfNotUnique && mysql_num_rows($result)>1) showError($errMsg);
      return @mysql_fetch_array($result);
    }

    private function getArrFromQuery($query, $errMsg) {
      $result   = @mysql_query($query) or showError($errMsg);
      $out = array();
      while ($record = @mysql_fetch_array($result)) {
        $out[] = $record;
      }
      return $out;
    }

    // PUBLIC SELECT FUNCTIONS
    // courses
    public function getCourse($course) {
      $query = "SELECT * FROM courses
                WHERE course_name='".addPostSlashes($course->getName())."'";
      $course = $this->getFirstRecord($query, "Unable to find course");
      return new Course($course['course_name'], $course['course_id']);
    }

    public function getCourseById($courseId) {
      $course = $this->getFirstRecord("SELECT * FROM courses where course_id=".$courseId, "Unable to find course with id ".$courseId);
      return new Course($course['course_name'], $course['course_id']);
    }

    public function getCourses() {
      $query = "SELECT * FROM courses";
      $result  = @mysql_query($query) or showError("Unable to retrieve courses");
      $courses = array();
      while ($course = @mysql_fetch_array($result)) {
        $courses[] = new Course($course['course_name'], $course['course_id']);
      }
      return $courses;
    }

    public function getCoursesByStudentId($studentId,$pageNr,$numPerPage) {
      $query = "SELECT course_id, course_name, subscription_class FROM courses, subscriptions
                WHERE course_id=subscription_course_id
                  AND subscription_student_id=".$studentId;
        if ($pageNr>0) {
        $query .= " ORDER BY course_name
                    LIMIT ".($pageNr-1)*$numPerPage.",".$numPerPage;
      }
      $result  = @mysql_query($query) or showError("Unable to retrieve courses for this student");
      $courses = array();
      while ($coursePlus = @mysql_fetch_array($result)) {
        $courses[] = $coursePlus;//new Course($course['course_name'], $course['course_id']);
      }
      return $courses;
    }

    public function calcNumCoursesByStudentId($studentId) {
      $query = "SELECT count(subscription_course_id) AS numCourses FROM subscriptions
                WHERE subscription_student_id=".$studentId;
      return $this->getFirstValue($query, "Unable to find number of students for this course");
    }
    
    public function calcMaxWeekevalsOfCoursesByStudentId($studentId)
    {
     $query = "SELECT MAX(numWeeks)FROM
              (SELECT COUNT(weekeval_id) AS numWeeks FROM weekevals,
              (SELECT subscription_id FROM subscriptions WHERE subscription_student_id=".$studentId.")as weeks 
              where weekeval_subscription_id=subscription_id group by weekeval_subscription_id)as totalWeeks";
       $result  = @mysql_query($query) or showError("Unable to retrieve max weeks for this student");
       $maxWeeks = @mysql_fetch_array($result);         
       return $maxWeeks[0];         
    }
    public function courseExists($course) {
      $query = "SELECT count(*) FROM courses WHERE course_name='".addPostSlashes($course->getName())."'";
      $num = $this->getFirstValue($query, "Unable to look for course".mysql_error());
      return $num>0;
    }

    // students
    public function getStudent($student) {
      $query   = "SELECT * FROM students
                  WHERE student_name='".addPostSlashes($student->getName())."'
                  AND student_birth='".addPostSlashes($student->getBirth())."'";
      $student = $this->getFirstRecord($query, "Unable to find student");
      return new Student($student['student_name'], $student['student_birth'], $student['student_id']);
    }
    public function getStudents() {
      $query = "SELECT * FROM students";
      $result  = @mysql_query($query) or showError("Unable to retrieve students");
      $students = array();
      while ($student = @mysql_fetch_array($result)) {
        $students[] = new Student($student['student_name'], $student['student_birth'],$student['student_id']);
      }
      return $students;
    }
    public function getStudentById($studentId) {
      $query   = "SELECT * FROM students
                  WHERE student_id=".$studentId;                  
      $student = $this->getFirstRecord($query, "Unable to find student by Id".$query);
      return new Student($student['student_name'], $student['student_birth'], $student['student_id']);
    }

    public function getStudentsByCourseId($courseId, $class="", $pageNr=-1, $numPerPage=20, $includeWeekevals=false,$presentCourse) {
      $query = "SELECT * FROM students, subscriptions
                WHERE subscription_course_id=".$courseId."
                  AND student_id=subscription_student_id
                  AND subscription_course='".$presentCourse."'";
      if ($class!="") {
        $query .= " AND subscription_class='".addPostSlashes($class)."'";
      }
      if ($pageNr>0) {
        $query .= " ORDER BY student_name
                    LIMIT ".($pageNr-1)*$numPerPage.",".$numPerPage;
      } 
      $result   = @mysql_query($query) or showError("Unable to retrieve students for this course");
      $students = array();
      while ($student     = @mysql_fetch_array($result)) {
        $nextStudent      = new Student($student['student_name'], $student['student_birth'], $student['student_id']);
        if ($includeWeekevals) {
          // find coursemarks for this student
          $query2    = "SELECT weekeval_id, weekeval_mark
                        FROM subscriptions, weekevals
                        WHERE subscription_id= weekeval_subscription_id
                          AND subscription_course_id=".$courseId."
                          AND subscription_student_id= ".$nextStudent->getId()."
                          AND subscription_course='".$presentCourse."'
                          ORDER BY weekeval_weeknr ASC";
          $result2   = @mysql_query($query2) or showError("Unable to find evaluations for this student");
          $weekevals = array();
          while ($next = @mysql_fetch_array($result2)) {
            $weekeval = new Weekeval();
            $weekeval->setId($next['weekeval_id']);
            $weekeval->setMark($next['weekeval_mark']);
            $weekevals[] = $weekeval;
          }
          $nextStudent->setWeekevals($weekevals);
        }
        $students[] = $nextStudent;
      }
      return $students;
    }
    
    public function calcNumStudentsByCourseId($courseId,$year,$class="") {
      $query = "SELECT count(student_id) AS numStudents FROM students, subscriptions
                WHERE subscription_course_id=".$courseId."
                  AND student_id=subscription_student_id
                  AND subscription_course='".$year."'";
      if ($class!="") {
        $query .= " AND subscription_class='".addPostSlashes($class)."'";
      }
      return $this->getFirstValue($query, "Unable to find number of students for this course");
    }

    public function studentExists($student) {
      $query = "SELECT count(*) FROM students
                WHERE student_name='".addPostSlashes($student->getName())."'
                AND student_birth='".addPostSlashes($student->getBirth())."'";
      $num = $this->getFirstValue($query, "Unable to look for student");
      return $num>0;
    }

    // weekevals
    public function getWeekevalById($weekevalId) {
      $query = "SELECT * FROM weekevals
                WHERE weekeval_id=".$weekevalId;
      $weekeval = $this->getFirstRecord($query, "Unable to find week evaluation with id ".$weekevalId);
      return new Weekeval($weekeval['weekeval_mark'], $weekeval['weekeval_comment'], $weekeval['weekeval_weeknr'], $weekeval['weekeval_subscription_id'], $weekeval['weekeval_id']);
    }
     public function getWeekevalByAll($courseId,$studentId,$weekNr) {
      $query = "SELECT * FROM weekevals where weekeval_subscription_id=(SELECT subscription_id FROM subscriptions
                WHERE subscription_course_id=".$courseId." and subscription_student_id=".$studentId.") and weekeval_weeknr=".$weekNr;
      $weekeval = $this->getFirstRecord($query, "Unable to find week evaluation with all parameters ".$weekevalId);
      return new Weekeval($weekeval['weekeval_mark'], $weekeval['weekeval_comment'], $weekeval['weekeval_weeknr'], $weekeval['weekeval_subscription_id'], $weekeval['weekeval_id']);
    }
      public function getWeekevalsByCourseAndStudent($courseId,$studentId,$presentCourse) {
      $query = "SELECT * FROM weekevals where weekeval_subscription_id=(SELECT subscription_id FROM subscriptions
                WHERE subscription_course_id=".$courseId." and subscription_student_id=".$studentId." and subscription_course='".$presentCourse."')";
      $result = @mysql_query($query) or showError("Unable to find evaluations for this student and course");
          while ($next = @mysql_fetch_array($result)) {
            $weekeval = new Weekeval();
            $weekeval->setId($next['weekeval_id']);
            $weekeval->setMark($next['weekeval_mark']);
            $weekevals[] = $weekeval;
          }
          return $weekevals;
      } 
    public function getWeekevalsByStudent($studentId)
    {
      $query= "SELECT weekeval_id, weekeval_mark,weekeval_weeknr,subscription_course_id from weekevals,
      (SELECT subscription_id,subscription_course_id from subscriptions where
      subscription_student_id=".$studentId.")as subs WHERE weekeval_subscription_id=subscription_id";   
      $result  = @mysql_query($query) or showError("Unable to retrieve weekevals for this student");
      $weekevals = array();
      $i=0;
      while ($next = @mysql_fetch_array($result)) {
      $weekevals[$i] = $next;
      $i++;
      }         
      return $weekevals; 
    }
      public function getYearOfWeekevalId($weekevalId) {
      $query = "select subscription_course from subscriptions,weekevals where 
                weekeval_id=".$weekevalId." and
                weekeval_subscription_id=subscription_id";
      $num = $this->getFirstValue($query, "Unable to get subscription course by this weekeval");
      return $num;
      }    
    
    // subscriptions
    public function getSubscriptionById($subscriptionId) {
      $query = "SELECT * FROM subscriptions
                WHERE subscription_id=".$subscriptionId;
      $subscription = $this->getFirstRecord($query, "Unable to find subscription with id ".$subscriptionId);
      return new Subscription($subscription['subscription_course_id'], $subscription['subscription_student_id'], $subscription['subscription_class'], $subscription['subscription_course'], $subscription['subscription_id']);
    }
    
    public function getYearsCourses() {
      $query = "select subscription_course from subscriptions group by subscription_course";
      $result = @mysql_query($query) or showError("Unable to retrieve courses for subscriptions");
      $years = array();
      $i=0;
      while ($next = @mysql_fetch_array($result)) {
      $years[$i] = $next;
      $i++;
      }
      return $years;
      }
      
      public function getYearsCoursesByStudent($courseId,$studentId) {
      $query = "select subscription_course from subscriptions where 
                subscription_course_id=".$courseId." and
                subscription_student_id=".$studentId."
                group by subscription_course DESC";
      $result = @mysql_query($query) or showError("Unable to retrieve courses for subscriptions");
      $years = array();
      $i=0;
      while ($next = @mysql_fetch_array($result)) {
      $years[$i] = $next;
      $i++;
      }
      return $years;
      }
 
    public function subscriptionExists($subscription) {
      $query   = "SELECT count(*) FROM subscriptions
                  WHERE subscription_course_id=".$subscription->getCourseId()."
                  AND subscription_student_id=".$subscription->getStudentId()."
                  AND subscription_course=".$subscription->getPresentCourse();
      $num = $this->getFirstValue($query, "Unable to look for subscription");
      return $num>0;
    }

    public function getSubscriptionsByCourseId($courseId) {
      $query  = "SELECT * FROM subscriptions WHERE subscription_course_id=".$courseId;
      $result = @mysql_query($query) or showError("Unable to retrieve subscriptions for this course");
      $subscriptions = array();
      while ($subscription = @mysql_fetch_array($result)) {
        $nextSubscription  = new Subscription($subscription['subscription_course_id'], $subscription['subscription_student_id'], $subscription['subscription_class'], $subscription['subscription_course'], $subscription['subscription_id']);
        $subscriptions[] = $nextSubscription;
      }
      return $subscriptions;
    }
    
    public function getSubscriptionByCourseByStudent($courseId,$studentId,$presentCourse) {
      $query  = "SELECT * FROM subscriptions WHERE subscription_course_id=".$courseId." and subscription_student_id=".$studentId." and subscription_course='".$presentCourse."'";
      $result = @mysql_query($query) or showError("Unable to retrieve subscriptions for this course and student");
      $subscription = @mysql_fetch_array($result);
      $subscription=new Subscription($subscription['subscription_course_id'], $subscription['subscription_student_id'], $subscription['subscription_class'], $subscription['subscription_course'], $subscription['subscription_id'], $subscription['subscription_course']);
      return $subscription;
    }
    
    //comments
     public function getCommentsByStudentId($studentId) {
      $query  = "SELECT * FROM comments WHERE comment_student_id=".$studentId." order by comment_date DESC";
      $result = @mysql_query($query) or showError("Unable to retrieve comments for this student");
      $comments= array();
      while ($comment = @mysql_fetch_array($result)) {
        $nextComment  = new Comment($comment['comment_text'], $comment['comment_date'], $comment['comment_id'], $comment['comment_user_id'],$comment['comment_student_id']);
        $comments[] = $nextComment;
      }
      return $comments;
    }
    public function getComment($commentId) {
      $query  = "SELECT * FROM comments WHERE comment_id=".$commentId;
      $result = @mysql_query($query) or showError("Unable to retrieve comment");
      $comment = @mysql_fetch_array($result);
      return new Comment($comment['comment_text'], $comment['comment_date'], $comment['comment_id'], $comment['comment_user_id'],$comment['comment_student_id']);
    }
     
    //parameters

    public function isDataBaseLoaded(){
      $query = "SELECT parameter_value from parameters where parameter_name='loaded'";
      return $this->getFirstValue($query, "Unable to find parameter loaded");
    }
    public function getConfigweeks() {
      $query = "SELECT parameter_value from parameters where parameter_name='weeks'";
      return $this->getFirstValue($query, "Unable to find parameter weeks");
    }
    public function getConfigpagging() {
      $query = "SELECT parameter_value from parameters where parameter_name='pagging'";
      return $this->getFirstValue($query, "Unable to find parameter pagging");
    }
    public function getPresentCourse() {
      $query = "SELECT parameter_value from parameters where parameter_name='present_course'";
      return $this->getFirstValue($query, "Unable to find parameter present_course");
      }
    // other
    public function calcNumWeeksByCourseId($courseId) {
      $query = "SELECT MAX(weekeval_weeknr) FROM weekevals, subscriptions
                WHERE weekeval_subscription_id=subscription_id
                  AND subscription_course_id=".$courseId;
      return $this->getFirstValue($query, "Unable to find number of weeks for this course");
    }

    public function getClasses($courseId=-1,$year) {
      $query = "SELECT DISTINCT subscription_class FROM subscriptions WHERE subscription_course='".$year."'";
      if ($courseId!=-1) {
        $query .= " and subscription_course_id=".$courseId;
      }
      $result = @mysql_query($query) or showError("Unable to find classes");
      $classes = array();
      while ($subscription = mysql_fetch_array($result)) {
        $classes[] = $subscription['subscription_class'];
      }
      return $classes;
    }

    // PUBLIC INSERT FUNCTIONS
    // courses
    public function insertCourse($course) {
      $query = "INSERT into courses (course_name) VALUES ('".addPostSlashes($course->getName())."')";
      @mysql_query($query) or showError("Unable to insert course");
    }

    // students
    public function insertStudent($student) {
      $query = "INSERT into students (student_name, student_birth) VALUES ('".addPostSlashes($student->getName())."','".addPostSlashes($student->getBirth())."')";
      @mysql_query($query) or showError("Unable to insert student");
    }

    // subscriptions
    public function insertSubscription($subscription) {
      $query = "INSERT into subscriptions (subscription_course_id, subscription_student_id, subscription_class,subscription_course)
                VALUES (".$subscription->getCourseId().",".$subscription->getStudentId().",
                        '".addPostSlashes($subscription->getClass())."','".$subscription->getPresentCourse()."')";
      @mysql_query($query) or showError("Unable to insert subscription");
    }

    // weekevals
    public function insertWeekeval($weekeval) {
      $query = "INSERT into weekevals (weekeval_mark, weekeval_comment, weekeval_weeknr, weekeval_subscription_id)
                VALUES (".$weekeval->getMark().",'".addPostSlashes($weekeval->getComment())."',".$weekeval->getWeeknr().",
                        ".$weekeval->getSubscriptionId().")";
      @mysql_query($query) or showError("Unable to insert week evaluation");
    }

    public function insertAllWeekevalsOfSemester($numWeeks,$oldNumWeeks=0)
    {
      // AJAX actions
      //  .....
      
      //$file = fopen("./sql/weekevals.sql", "r+");
      $insert         = "";
      $courses        = $this->getCourses();
      $students       = $this->getStudents();
      $presentCourse  = $this->getPresentCourse();
      if($numWeeks-$oldNumWeeks > 0 && $this->isDataBaseLoaded())
      {
       foreach($students as $student)
        {
          foreach($courses as $course)
          {
            $subscription=$this->getSubscriptionByCourseByStudent($course->getId(),$student->getId(),$presentCourse);
            if($subscription->getId()==null) continue;
            if($numWeeks-$oldNumWeeks > 0 )
            {
              $insert="INSERT into weekevals (weekeval_mark, weekeval_comment, weekeval_weeknr, weekeval_subscription_id) VALUES "; 
              for($weekNr=$oldNumWeeks+1;$weekNr<=$numWeeks;$weekNr++)
              { $end=($weekNr==$numWeeks?"":",");
                   $weekeval = new Weekeval(-1, "", $weekNr, $subscription->getId(),-1);
                   $insert.="(".$weekeval->getMark().",'".addPostSlashes($weekeval->getComment())."',".$weekeval->getWeeknr().",".$weekeval->getSubscriptionId().")"
                   .$end;
              }
              @mysql_query($insert) or showError("Cannot insert student into DataBase");
             }                  
           }       
          }
        }
        if($numWeeks-$oldNumWeeks < 0)
        {
           echo("entro a esborrar");
          for($weekNr=$oldNumWeeks;$weekNr>$numWeeks;$weekNr--){
          $delete="DELETE from weekevals where weekeval_weeknr=".$weekNr;
          mysql_query($delete) or showError("Cannot delete student into DataBase");
          } 
        }
        //parse_mysql_dump("./sql/weekevals.sql");
      //}
      //if($numWeeks-$oldNumWeeks < 0)
    }
    
    //comments
    public function addComment($comment) {
      $query = "INSERT into comments (comment_text,comment_date,comment_user_id,comment_student_id) VALUES 
      ('".$comment->getText()."','".$comment->getDate()."','".$comment->getUserId()."',".$comment->getStudentId().")";
      @mysql_query($query) or showError("Unable to insert comments in this student");
    }
    
    //parameters
    public function setConfiguration($configWeeks=12,$configPagging=15) {
      $query = "INSERT into parameters (parameter_name,parameter_value) VALUES ('weeks',".$configWeeks."),('pagging',".$configPagging.")";
      @mysql_query($query) or showError("Unable to insert parameters of configuration");
    }

    // other
    public function addWeek($courseId) {
      $weekNr = $this->calcNumWeeksByCourseId($courseId) + 1;
      $subscriptions = $this->getSubscriptionsByCourseId($courseId);
      foreach ($subscriptions as $subscription) {
        $eval = new Weekeval(-1, "", $weekNr, $subscription->getId());
        $this->insertWeekeval($eval);
      }
    }

    // PUBLIC UPDATE FUNCTIONS
    
    //students
    
    public function updateStudent($student) {
      $query = "UPDATE students
                SET student_name='".$student->getName()."',student_birth='".$student->getBirth()."'
                WHERE student_id=".$student->getId();
      @mysql_query($query) or showError("Unable to update student".$query);
    }
    // marks
    public function updateWeekeval($weekeval) {
      $query = "UPDATE weekevals
                SET weekeval_mark=".$weekeval->getMark().",weekeval_comment='".addPostSlashes($weekeval->getComment())."'
                WHERE weekeval_id=".$weekeval->getId();
      @mysql_query($query) or showError("Unable to update week evaluation");
    }
    public function updateWeekevalComment($weekeval) {
      $query = "UPDATE weekevals
                SET weekeval_comment='".addPostSlashes($weekeval->getComment())."'
                WHERE weekeval_id=".$weekeval->getId();
      @mysql_query($query) or showError("Unable to update week evaluation comment");
    }

    public function updateWeekevalMark($weekeval) {
      $query = "UPDATE weekevals
                SET weekeval_mark=".$weekeval->getMark()."
                WHERE weekeval_id=".$weekeval->getId();
      @mysql_query($query) or showError("Unable to update week evaluation mark");
    }
    
    //subscriptions
    
    public function updateSubscription($subscription) {
      $query = "UPDATE subscriptions
                SET subscription_class='".$subscription->getClass()."'WHERE subscription_id=".$subscription->getId();
      @mysql_query($query) or showError("Unable to update subscription");
    }
    
    //parameters
    public function updateConfiguration($configWeeks=12,$configPagging=15) {
      $query = "UPDATE parameters SET parameter_value=".$configWeeks." WHERE parameter_name='weeks'";
      @mysql_query($query) or showError("Unable to update parameter weeks");
      $query = "UPDATE parameters SET parameter_value=".$configPagging." WHERE parameter_name='pagging'";
      @mysql_query($query) or showError("Unable to update parameter pagging");
    }
    public function setDataBaseLoaded($loaded){
      $query = "UPDATE parameters SET parameter_value=".$loaded." WHERE parameter_name='loaded'";
      @mysql_query($query) or showError("Unable to update parameter loaded of configuration");    
    }
    public function setYearOfPresentCourse($year){
      $query = "UPDATE parameters SET parameter_value='".$year."' WHERE parameter_name='present_course'";
      @mysql_query($query) or showError("Unable to update parameter present_course of configuration");    
    }
  //PUBLIC DELETE FUNCTIONS
   public function deleteComment($commentId){
      $query = "DELETE from comments where comment_id=".$commentId;
      @mysql_query($query) or showError("Unable to delete comment");    
  }
}
?>