<?php

  // MISC FUNCTIONS

  function showError($info="") {
    $errtpl = new Template("templates");
    $errtpl->set_file("error_tp", "error.tpl");
    $errtpl->set_var("INFO", $info);
    $errtpl->pparse($htmlcode, "error_tp");
    die();
  }

  function addPostSlashes($string) {
    if (get_magic_quotes_gpc()==1) return $string;
    else return addslashes($string);
  }

  function stripPostSlashes($string) {
    if (get_magic_quotes_gpc()==1) return stripslashes($string);
    else return $string;
  }

  function buildUrl($arrPars=array(), $keeps = array('weekmarkId', 'courseId', 'pageNr', 'class','year')) {
    foreach ($keeps as $keep) {
      if (!isset($arrPars[$keep]) && isset($_REQUEST[$keep])) $arrPars[$keep] = $_REQUEST[$keep];
    }
    $outList = array();
    foreach ($arrPars as $key=>$val) {
      $outList[] = $key."=".$val;
    }
    $out = implode("&", $outList);
    $out = ($out==""?"":"?").$out;
    return $_SERVER['PHP_SELF'].$out;
  }

  function endsWith($haystack, $needle) {
    return (substr($haystack, strlen($haystack) - strlen($needle)) == $needle);
  }

  function setConfiguration($configFile, $arrPars) {
    $configdata = implode("", file($configFile)) or showError("Cannot open configuration file");
    foreach ($arrPars as $key=>$val) {
      $rex = "/'".$key."'[\\s]*=>[\\s]*'[^']*'/";
      $configdata = preg_replace($rex, "'".$key."'=>'".$val."'", $configdata);
    }
    $fp = fopen($configFile, "w") or showError("Unable to write configuration file");
    fwrite($fp, $configdata);
    fclose($fp);
  }

  function parse_mysql_dump($url, $ignoreerrors = false) {
    $lines = file($url);
    $query = "";
    foreach($lines as $line) {
      $line = trim($line);
      if (($line != "") && (substr($line, 0, 2) != "--") && (substr($line, 0, 1) != "#")) {
        $query .= $line;
        if(preg_match("/;\s*$/", $line)) {
          $result = @mysql_query($query);
          if (!$result && !$ignoreerrors) showError(mysql_error());
          $query = "";
        }
      }
    }
  }
 function validateDate($strdate){

    //Check the length of the entered Date value
    if((strlen($strdate)<10)OR(strlen($strdate)>10)){
    return(" * Enter the date in 'yyyy-mm-dd' format");
    }
    else{
      //The entered value is checked for proper Date format
      if((substr_count($strdate,"-"))<>2){
        return(" * Enter the date in 'yyyy-mm-dd' format");
      }
      else{
        $pos=strpos($strdate,"-");
        $date=substr($strdate,($pos+4),strlen($strdate));
        $result=ereg("^[0-9]+$",$date,$trashed);
        if(!($result)){return " * Enter a Valid Date1".$date;}
        else{
          if(($date<=0)OR($date>31)){return " * Enter a Valid Date";}
        }
        $month=substr($strdate,($pos+1),($pos-2));
        if(($month<=0)OR($month>12)){return " * Enter a Valid Month";}
        else{
          $result=ereg("^[0-9]+$",$month,$trashed);
          if(!($result)){return " * Enter a Valid Month";}
        }
        $year=substr($strdate,0,$pos);
        $result=ereg("^[0-9]+$",$year,$trashed);
        if(!($result)){return " * Enter a Valid year".$year;}
        else{
          if(($year<1900)OR($year>2200)){return " * Enter a year between 1900-2200";}
        }
      }
    }
    return("");
}

function validateConfigWeeks($configWeeks){
  if(empty($configWeeks))             {return "* Enter a number of weeks";} 
  if($configWeeks  > 40)              {return "* Number to much big";}
  if(!ereg("[0-9]{2}",$configWeeks,$trashed)) {return "* Enter a valid number";}
  return"";
}
function validateConfigPagging($configPagging){
  if(empty($configPagging))                    {return "* Enter a number of rows";} 
  if($configPagging  < 1)                      {return "* Enter a number > 1";}
  if(!ereg("[0-9]{2}",$configPagging,$trashed)) {return "* Enter a valid number";}
  return"";
}
function validateConfigYear($configYear){
  if((strlen($configYear)<9)OR(strlen($configYear)>9) && (substr_count($configYear,"/"))<>4)  {return "* Enter a course in 'yyyy/yyyy' format";}
  if(empty($configYear))                          {return "* Enter a course";} 
  return"";
}
?>