var loadingGif = new Image();
loadingGif.src = "Styles/Icons/loading.gif";

// KEY NAVIGATION

const LEFT  = 37;
const UP    = 38;
const RIGHT = 39;
const DOWN  = 40;

var grid         = new Object();
grid.rows        = new Array();
grid.activeRow   = -1;
grid.activeCol   = -1;
grid.isLoaded    = false;

grid.loadTable = function(tableId) {
  table = document.getElementById(tableId);
  if (!table) return false;
  rows = findChildNodes(table, "tr");
  for (var i=1; i<rows.length; i++) {
    grid.rows[i-1] = new Array();
    row = rows[i];
    var cells = findChildNodes(row, "td");
    for (var j=2; j<cells.length; j++) {
      cell = cells[j];
      var links = findChildNodes(cell, "a");
      var link  = links[0];
      if (!link) continue;
      grid.rows[i-1][j-2] = link;
      if (link.className.indexOf("selectedmark")!=-1) {
        grid.activeRow = i-1;
        grid.activeCol = j-2;
      }
    }
  }
  if (grid.rows.length>0 && grid.rows[1].length>0) {
    grid.isLoaded = true;
    if (weekevalId==-1) {
      var query  = grid.rows[0][0].href.split("?")[1];
      weekevalId = findQueryPar(query, "weekevalId");
    }
  }
  if (grid.isLoaded && grid.activeRow==-1) grid.activeRow=0;
  if (grid.isLoaded && grid.activeCol==-1) grid.activeCol=0;
   grid.moveCursor(0, 0);
  // undo disabled form
  document.forms.editmarkpanel.className = "";
  document.forms.editmarkpanel.editCommentOk.disabled = false;
}

grid.moveCursor = function(dx, dy) {
  if (!grid.isLoaded) return;
  if (weekevalId<=0) return;
  var currCell = grid.rows[grid.activeRow][grid.activeCol];
  currCell.className = currCell.className.replace("selectedmark", "");
  grid.activeCol += dx;
  grid.activeRow += dy;
  if (grid.activeRow<0) grid.activeRow = 0;
  if (grid.activeRow>grid.rows.length-1) grid.activeRow = grid.rows.length-1;
  if (grid.activeCol<0) grid.activeCol = 0;
  if (grid.activeCol>grid.rows[1].length-1) grid.activeCol = grid.rows[1].length-1;
  currCell = grid.rows[grid.activeRow][grid.activeCol];
  currCell.className +=" selectedmark";
  // send Ajax request for comment and mark
  showData(currCell);
}

function handleNav(key) {
  switch(key) {
    case LEFT:  grid.moveCursor(-1, 0); break;
    case UP:    grid.moveCursor(0, -1); break;
    case RIGHT: grid.moveCursor(1, 0); break;
    case DOWN:  grid.moveCursor(0, 1); break;
  }
}

function showData(link){
  var query         = link.href.split("?")[1];
  var parWeekevalId = findQueryPar(query, "weekevalId");
  weekevalId = parWeekevalId;
  var url        = 'showCourse.php';
  var pars       = "ajaxWeekevalId="+weekevalId;
  var myAjax = new Ajax.Request(url, {method:'get', parameters:pars, onComplete: doShow});
   
}

function doShow(response) {
  var resp = response.responseText;
  var chunks  = resp.split("&");
  var comment = chunks[0].split("=")[1];
  var mark    = chunks[1].split("=")[1];
  var name    = chunks[2].split("=")[1];
  var class   = chunks[3].split("=")[1];
  var age     = chunks[4].split("=")[1];
  var photo   = chunks[5].split("=")[1];
  var weekevalId   = chunks[6].split("=")[1];
  var year   = chunks[7].split("=")[1];
  document.getElementById("fiche").style.visibility  = "visible";
  document.forms.editmarkpanel.weekevalId.value = weekevalId;
  document.forms.editmarkpanel.areaComments.value = comment;
  document.getElementById("csname").innerHTML  = name;
  document.getElementById("csage").innerHTML   = age;
  document.getElementById("csclass").innerHTML   = class;
  document.images.csphoto.src = "Images/Students/" + photo;
  document.getElementById("more").href  = "./fiche.php?weekevalId="+weekevalId+"&year="+year;

  objMark_1 = document.getElementById("mark_1");
  objMark0  = document.getElementById("mark0");
  objMark1  = document.getElementById("mark1");
  objMark2  = document.getElementById("mark2");
  objMark3  = document.getElementById("mark3");
  objMark4  = document.getElementById("mark4");
  objMark5  = document.getElementById("mark5");

  objMark_1.className = objMark_1.className.replace("selectedmark", "").trim();
  objMark0.className  = objMark0.className.replace("selectedmark", "").trim();
  objMark1.className  = objMark1.className.replace("selectedmark", "").trim();
  objMark2.className  = objMark2.className.replace("selectedmark", "").trim();
  objMark3.className  = objMark3.className.replace("selectedmark", "").trim();
  objMark4.className  = objMark4.className.replace("selectedmark", "").trim();
  objMark5.className  = objMark5.className.replace("selectedmark", "").trim();

  if (parseInt(mark)==-1) objMark_1.className += " selectedmark";
  if (parseInt(mark)==0)  objMark0.className += " selectedmark";
  if (parseInt(mark)==1)  objMark1.className += " selectedmark";
  if (parseInt(mark)==2)  objMark2.className += " selectedmark";
  if (parseInt(mark)==3)  objMark3.className += " selectedmark";
  if (parseInt(mark)==4)  objMark4.className += " selectedmark";
  if (parseInt(mark)==5)  objMark5.className += " selectedmark";
}

function showLoading() {
  document.getElementById("lastcol").innerHTML = "<img src='Styles/Icons/loading.gif' alt='' />";
}

function showcourseLoadEvents() {
  grid.loadTable("marksGrid");
  window.onkeydown = function(evt) {
    handleNav(evt.keyCode);
  }
  objLnkAddWeek = document.getElementById('addWeekLnk');
  objLnkAddWeek.onclick = function() {
    showLoading();
    setTimeout("window.location.href='" + objLnkAddWeek.href + "'", 100);
    return false;
  }
}

addLoadEvents(showcourseLoadEvents);