DROP TABLE IF EXISTS `courses`;
DROP TABLE IF EXISTS `students`; 
DROP TABLE IF EXISTS `subscriptions`;  
DROP TABLE IF EXISTS `weekevals`;
DROP TABLE IF EXISTS `comments`;
DROP TABLE IF EXISTS `parameters`;

CREATE TABLE IF NOT EXISTS `courses` (
  `course_id` int(10) NOT NULL auto_increment,
  `course_name` varchar(255) NOT NULL default '',
  `course_code` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`course_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `students` (
  `student_id` int(10) NOT NULL auto_increment,
  `student_name` varchar(255) NOT NULL default '',
  `student_birth` date NOT NULL default '0000-00-00',
  `student_nr` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`student_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `subscriptions` (
  `subscription_id` int(10) NOT NULL auto_increment,
  `subscription_course_id` int(10) NOT NULL default '0',
  `subscription_student_id` int(10) NOT NULL default '0',
  `subscription_class` varchar(20) NOT NULL default '',
  `subscription_course` varchar(9) NOT NULL default '0',
  PRIMARY KEY  (`subscription_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `weekevals` (
  `weekeval_id` int(10) NOT NULL auto_increment,
  `weekeval_mark` int(2) NOT NULL default '0',
  `weekeval_comment` text NOT NULL,
  `weekeval_weeknr` int(2) NOT NULL default '0',
  `weekeval_subscription_id` int(10) NOT NULL default '0',
  PRIMARY KEY  (`weekeval_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `comments` (
  `comment_id` int(10) NOT NULL auto_increment,
  `comment_text` varchar(200) NOT NULL default '',
  `comment_date` date NOT NULL default '0000-00-00',
  `comment_user_id` int(10) NOT NULL default '0',
  `comment_student_id` int(10) NOT NULL default '0',
  PRIMARY KEY  (`comment_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `parameters` (
  `parameter_name` varchar(50) NOT NULL default '',
  `parameter_value` text NOT NULL,
  PRIMARY KEY  (`parameter_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `parameters` VALUES ('complete', '1');
INSERT INTO `parameters` VALUES ('loaded', '0');
INSERT INTO `parameters` VALUES ('present_course', '0');