<?php

  require_once "Classes/DataBase.class.php";
  require_once "Classes/Template.class.php";
  require_once("Includes/functions.inc.php");

  
  $db = new DataBase();
  $courses          = $db->getCourses();
  $weekevalId       = isset($_REQUEST['weekevalId'])?$_REQUEST['weekevalId']:-1;
  $deleteComment    = isset($_REQUEST['commentId'])?$_REQUEST['commentId']:-1;
  $modifyComment    = isset($_REQUEST['modifyId'])?$_REQUEST['modifyId']:-1;
  $modified         = isset($_REQUEST['modified'])?$_REQUEST['modified']:-1;
  $year             = isset($_REQUEST['year'])?$_REQUEST['year']:-1;
  if ($weekevalId!=-1) {
    $currWeekeval     = $db->getWeekevalById($weekevalId);
    
    // get data for this weekeval
    $currSubscription = $db->getSubscriptionById($currWeekeval->getSubscriptionId());
    $courseId         = $currSubscription->getCourseId();
    $studentId        = $currSubscription->getStudentId();
    $currClass        = $currSubscription->getClass();
    $currStudent      = $db->getStudentById($studentId);
  }
  //form fields
  $classes          = $db->getClasses($courseId,$year);
  $birth  = $currStudent->getBirth();
  $name   = $currStudent->getName();
  
  //messages form fields
  $now              = date('Y-m-d', time());
  $message          = "";
  $comments         = $db->getCommentsByStudentId($studentId);
  //form student data
  if(isset($_REQUEST['studentData'])){
  $name     = $_REQUEST['name'];
  $birth    = $_REQUEST['birth'];
  $picture  = $_FILES['picture'];
  if(endsWith($picture['name'],"jpg") || endsWith($picture['name'],"JPG")){
    $newPictureName="student".$studentId.".jpg";
    copy($picture[tmp_name],"./Images/Students/".$newPictureName);
    $currStudent      = $db->getStudentById($studentId);  
  }
  $dateError=validateDate($birth);
  if($name==""){$nameError="* Enter a name";}
  if($name!="" && $dateError==""){
    $currStudent->setName($name);
    $currStudent->setBirth($birth);
    $db->updateStudent($currStudent);
  }
  }
  //form set class
  if(isset($_REQUEST['setClass'])){
    $courseSelected   = $_REQUEST['courses'];
    $classSelected    = $_REQUEST['classes'];
    if($courseSelected  == -1){
      foreach($courses as $course){
        $subscription = $db->getSubscriptionByCourseByStudent($course->getId(),$studentId);
        $subscription->setClass($classSelected);
        $db->updateSubscription($subscription);
      }
    }
    else{
      $subscription = $db->getSubscriptionByCourseByStudent($courseSelected,$studentId);
      $subscription->setClass($classSelected);
      $db->updateSubscription($subscription);
    } 
  }
   if($modified!=-1){
      $db->deleteComment($modified);
    }
  //form messages
  if(isset($_REQUEST['addMessage'])){
  $dateMessage  = $_REQUEST['date'];
  $commentText      = $_REQUEST['message'];
  $dateMessageError=validateDate($dateMessage);
  $now          = $dateMessage;
  if($commentText==""){$messageError="* Message is empty";}
  if($commentText!="" && $dateMessageError==""){
    $newComment = new Comment($commentText,$dateMessage,-1,null,$studentId);
    $db->addComment($newComment);
    $comments   = $db->getCommentsByStudentId($studentId);
    $commentText    = "";
    $now        = date('Y-m-d', time());
  }
  }
  //deleting messages
  if($deleteComment!=-1){
    $db->deleteComment($deleteComment);
    $comments   = $db->getCommentsByStudentId($studentId);
  }
  //modifing messages
    if($modifyComment!=-1){
      $now          = $db->getComment($modifyComment)->getDate();
      $commentText  = $db->getComment($modifyComment)->getText();
      $comments     = $db->getCommentsByStudentId($studentId);
    }
    
  // BUILD PAGE
  $tpl = new Template("templates/");
  // set files and blocks
  $tpl->set_file("page_tp", "page.tpl");
  $tpl->set_block("page_tp", "LICOURSE", "licourses");
  $tpl->set_file("fiche_tp", "fiche.tpl");
  $tpl->set_block("fiche_tp", "HEADBLOCK", "headblock");
  $tpl->set_block("fiche_tp", "CONTENTBLOCK", "contentblock");
  $tpl->set_block("CONTENTBLOCK", "SELECTCOURSE", "selectcourse");
  $tpl->set_block("CONTENTBLOCK", "SELECTCLASS", "selectclass");
  $tpl->set_block("CONTENTBLOCK", "SHOWMESSAGES", "showmessages");
 //generate fiche
  $tpl->set_var("STUDENTNAME", $currStudent->getName());
  $tpl->set_var("WEEKEVALID", $weekevalId );
  
   $tpl->set_var("ACTIONMARKPANEL", $_SERVER['PHP_SELF']);
    $tpl->set_var("CURRSTUDENTNAME", $name);
    $tpl->set_var("NAMEERROR", $nameError);
    $tpl->set_var("CURRSTUDENTAGE", $currStudent->getAge());
     $tpl->set_var("CURRSTUDENTPHOTO","./images/students/".$currStudent->getPhoto());
    //generate change class
    foreach ($courses as $course) {
    $tpl->set_var("COURSEID", $course->getId()); 
    $tpl->set_var("COURSE", $course->getName());
    $tpl->parse("selectcourse", "SELECTCOURSE", true);
  }   
   foreach ($classes as $class) {
    $tpl->set_var("CLASS", $class);
    $tpl->parse("selectclass", "SELECTCLASS", true);
  }
  //generate new message
  if($modifyComment!=-1){
    $tpl->set_var("MODIFIED", "<input type=\"hidden\" name=\"modified\" value=\"".$modifyComment."\" />");
    }
    $tpl->set_var("CURRSTUDENTCLASS", $currClass);
    $tpl->set_var("CURRSTUDENTBIRTH", $birth);
    $tpl->set_var("NOW", $now);
    $tpl->set_var("DATEERROR", $dateError);
    $tpl->set_var("COMMENTTEXT", $commentText);
    $tpl->set_var("DATEMESSAGEERROR", $dateMessageError);
    $tpl->set_var("MESSAGEERROR", $messageError);
    
  //generate show historic messages
   foreach ($comments as $comment) {
    $tpl->set_var("DATE", $comment->getDate());
    $tpl->set_var("COMMENT", $comment->getText());
    $tpl->set_var("DELETE", $_SERVER['PHP_SELF']."?weekevalId=".$weekevalId."&amp;commentId=".$comment->getId());
    $tpl->set_var("MODIFY", $_SERVER['PHP_SELF']."?weekevalId=".$weekevalId."&amp;modifyId=".$comment->getId());
    $tpl->parse("showmessages", "SHOWMESSAGES", true);
  }
  $tpl->set_var("YEAR",$year);
  // generate page
  foreach ($courses as $course) {
    $tpl->set_var("NAME_LICOURSE", $course->getName());
    $tpl->set_var("URL_LICOURSE",  "showCourse.php?courseId=".$course->getId());
    $tpl->parse("licourses",  "LICOURSE", true);
  }
  $tpl->set_var("TITLE", "StudentsWatch - view course");
  $tpl->parse("HEADEXTRA", "HEADBLOCK");
  $tpl->parse("CONTENT", "CONTENTBLOCK");
  $tpl->pparse("htmlcode", "page_tp");

?>