<?

  require_once "Classes/DataBase.class.php";
  require_once "Classes/Template.class.php";

  $db = new DataBase();
  $configWeeks    = $db->getConfigweeks();
  $configPagging  = $db->getConfigpagging();
  $presentCourse  = $db->getPresentCourse();

  function findCsvDate($string) {
    $d       = explode(" ", $string);
    $dformat = explode("/",$d[2]);
    $year    = trim($dformat[2]);
    $dformat[2] = $dformat[0];
    $dformat[0] = $year;
    return implode("/",$dformat);
  }

  if (!empty($_FILES['importcsv'])) {
    if($configWeeks > 40){showError("Number of weeks too much big");}
    // load the data
    $rows = file($_FILES['importcsv']['tmp_name']) or showError("Unable to open csv file");
    // init business object
    $class = "X";
    for($i=1; $i<count($rows); $i++) {
      $row = $rows[$i];
      $cells = explode(";", $row);
      if ($cells[0]!="") {
        // course definition row
        $class = ($cells[1]==""?"X":$cells[1]);  // change class
        $course = new Course();
        $course->setName($cells[0]);
        if (!$db->courseExists($course)) {
          // new course
          $db->insertCourse($course);
        }
        $course = $db->getCourse($course); //setting course id
      } else {
        // new subscription
        $studentName  = $cells[3];
        $studentBirth = $cells[4];
        $student = new Student($studentName);
        $student->setBirth(findCsvDate($studentBirth));
        if (!$db->studentExists($student)) {
          // new student
          $db->insertStudent($student);  
        }
        $student = $db->getStudent($student); //setting student id
        $subscription = new Subscription();
        $subscription->setStudentId($student->getId());
        $subscription->setCourseId($course->getId());
        $subscription->setClass($class);
        $subscription->setPresentCourse($presentCourse);
        if(!$db->subscriptionExists($subscription)) {
          $db->insertSubscription($subscription);
          /*$subscription=$subscription->getSubscription($subscription);
          $totalWeeks=calcNumWeeksByCourseId($course->getId());
          for($numWeeks=0;$numWeeks < $totalWeeks;$numMarks++)
          {
            $week=new Weekeval(-1,"", $numWeeks,$subscription->getId(),-1);
          }*/
        }
      }
    }
    $db->setDataBaseLoaded(true);
    $db->insertAllWeekevalsOfSemester($configWeeks,0);
  }
  
   if(isset($_REQUEST['postback'])) 
   { $configWeeks   = $_REQUEST['configWeeks'];
     $configPagging = $_REQUEST['configPagging'];
     $configYear    = $_REQUEST['year'];

      $configWeeksError=validateConfigWeeks($configWeeks);
      $configPaggingError=validateConfigPagging($configPagging);
      $configYearError=validateConfigYear($configYear);
      if($configWeeksError=="" && $configPaggingError=="" && $configYearError=="")
      {
        $db->updateConfiguration($configWeeks,$configPagging);
        $db->insertAllWeekevalsOfSemester($configWeeks,$configWeeks);
        $db->setYearOfPresentCourse($configYear);
      }
      $configWeeks    = $db->getConfigweeks();
      $configPagging  = $db->getConfigpagging();
      $presentCourse  = $configYear;
   }
    
  $courses = $db->getCourses();

  // BUILD PAGE
  $tpl = new Template("templates/");
  // set files and blocks
  $tpl->set_file("page_tp", "page.tpl");
  $tpl->set_block("page_tp", "LICOURSE", "licourses");
  $tpl->set_file("import_tp", "import.tpl");
  $tpl->set_block("import_tp", "HEADBLOCK", "headblock");
  $tpl->set_block("import_tp", "CONTENTBLOCK", "contentblock");
  $tpl->set_var("ACTION", $_SERVER['PHP_SELF']);
  $tpl->set_var("IMPORT","Import");// $db->isComplete()?"Re-Import":"Import");
  $tpl->set_var("ACTION", $_SERVER['PHP_SELF']);
  $tpl->set_var("CONFIGWEEKS",$configWeeks);
   $tpl->set_var("CONFIGWEEKSERROR",$configWeeksError);
  $tpl->set_var("CONFIGPAGGING",$configPagging);
  $tpl->set_var("CONFIGPAGGINGERROR",$configPaggingError);
  $tpl->set_var("CONFIGYEAR",$presentCourse);
  $tpl->set_var("CONFIGYEARERROR",$configYearError);
  
  $tpl->set_var("PARMS","Set Parameters");
  // generate page
  foreach ($courses as $course) {
    $tpl->set_var("NAME_LICOURSE", $course->getName());
    $tpl->set_var("URL_LICOURSE",  "showCourse.php?courseId=".$course->getId());
    $tpl->parse("licourses",  "LICOURSE", true);
  }
  $tpl->set_var("TITLE", "StudentsWatch - view course");
  $tpl->parse("HEADEXTRA", "HEADBLOCK");
  $tpl->parse("CONTENT", "CONTENTBLOCK");
  $tpl->pparse("htmlcode", "page_tp");

?>